
# TODO: This file is dangerous because the enums could potentially change between API versions. Should transmit as part of the JSON.
# To regenerate this file, nagivate to the top level of the ODrive repository and run:
#   python Firmware/interface_generator_stub.py --definitions Firmware/odrive-interface.yaml --template tools/enums_template.j2 --output tools/odrive/enums.py

# ODrive.GpioMode
GPIO_MODE_DIGITAL                        = 0
GPIO_MODE_DIGITAL_PULL_UP                = 1
GPIO_MODE_DIGITAL_PULL_DOWN              = 2
GPIO_MODE_ANALOG_IN                      = 3
GPIO_MODE_UART_A                         = 4
GPIO_MODE_UART_B                         = 5
GPIO_MODE_UART_C                         = 6
GPIO_MODE_CAN_A                          = 7
GPIO_MODE_I2C_A                          = 8
GPIO_MODE_SPI_A                          = 9
GPIO_MODE_PWM                            = 10
GPIO_MODE_ENC0                           = 11
GPIO_MODE_ENC1                           = 12
GPIO_MODE_ENC2                           = 13
GPIO_MODE_MECH_BRAKE                     = 14
GPIO_MODE_STATUS                         = 15
GPIO_MODE_BRAKE_RES                      = 16
GPIO_MODE_AUTO                           = 17

# ODrive.StreamProtocolType
STREAM_PROTOCOL_TYPE_FIBRE               = 0
STREAM_PROTOCOL_TYPE_ASCII               = 1
STREAM_PROTOCOL_TYPE_STDOUT              = 2
STREAM_PROTOCOL_TYPE_ASCII_AND_STDOUT    = 3
STREAM_PROTOCOL_TYPE_OTHER               = 4

# ODrive.Can.Protocol
PROTOCOL_SIMPLE                          = 0x00000001

# ODrive.Axis.AxisState
AXIS_STATE_UNDEFINED                     = 0
AXIS_STATE_IDLE                          = 1
AXIS_STATE_STARTUP_SEQUENCE              = 2
AXIS_STATE_FULL_CALIBRATION_SEQUENCE     = 3
AXIS_STATE_MOTOR_CALIBRATION             = 4
AXIS_STATE_ENCODER_INDEX_SEARCH          = 6
AXIS_STATE_ENCODER_OFFSET_CALIBRATION    = 7
AXIS_STATE_CLOSED_LOOP_CONTROL           = 8
AXIS_STATE_LOCKIN_SPIN                   = 9
AXIS_STATE_ENCODER_DIR_FIND              = 10
AXIS_STATE_HOMING                        = 11
AXIS_STATE_ENCODER_HALL_POLARITY_CALIBRATION = 12
AXIS_STATE_ENCODER_HALL_PHASE_CALIBRATION = 13

# ODrive.Controller.ControlMode
CONTROL_MODE_VOLTAGE_CONTROL             = 0
CONTROL_MODE_TORQUE_CONTROL              = 1
CONTROL_MODE_VELOCITY_CONTROL            = 2
CONTROL_MODE_POSITION_CONTROL            = 3

# ODrive.ComponentStatus
COMPONENT_STATUS_NOMINAL                 = 0
COMPONENT_STATUS_NO_RESPONSE             = 1
COMPONENT_STATUS_INVALID_RESPONSE_LENGTH = 2
COMPONENT_STATUS_PARITY_MISMATCH         = 3
COMPONENT_STATUS_ILLEGAL_HALL_STATE      = 4
COMPONENT_STATUS_POLARITY_NOT_CALIBRATED = 5
COMPONENT_STATUS_PHASES_NOT_CALIBRATED   = 6
COMPONENT_STATUS_NUMERICAL_ERROR         = 7
COMPONENT_STATUS_MISSING_INPUT           = 8
COMPONENT_STATUS_RELATIVE_MODE           = 9
COMPONENT_STATUS_UNCONFIGURED            = 10
COMPONENT_STATUS_OVERSPEED               = 11
COMPONENT_STATUS_INDEX_NOT_FOUND         = 12
COMPONENT_STATUS_BAD_CONFIG              = 13
COMPONENT_STATUS_NOT_ENABLED             = 14
COMPONENT_STATUS_SPINOUT_DETECTED        = 15

# ODrive.ProcedureResult
PROCEDURE_RESULT_SUCCESS                 = 0
PROCEDURE_RESULT_BUSY                    = 1
PROCEDURE_RESULT_CANCELLED               = 2
PROCEDURE_RESULT_DISARMED                = 3
PROCEDURE_RESULT_NO_RESPONSE             = 4
PROCEDURE_RESULT_POLE_PAIR_CPR_MISMATCH  = 5
PROCEDURE_RESULT_PHASE_RESISTANCE_OUT_OF_RANGE = 6
PROCEDURE_RESULT_PHASE_INDUCTANCE_OUT_OF_RANGE = 7
PROCEDURE_RESULT_UNBALANCED_PHASES       = 8
PROCEDURE_RESULT_INVALID_MOTOR_TYPE      = 9
PROCEDURE_RESULT_ILLEGAL_HALL_STATE      = 10

# ODrive.EncoderId
ENCODER_ID_NONE                          = 0
ENCODER_ID_INC_ENCODER0                  = 1
ENCODER_ID_INC_ENCODER1                  = 2
ENCODER_ID_INC_ENCODER2                  = 3
ENCODER_ID_SENSORLESS_ESTIMATOR          = 4
ENCODER_ID_SPI_ENCODER0                  = 5
ENCODER_ID_SPI_ENCODER1                  = 6
ENCODER_ID_SPI_ENCODER2                  = 7
ENCODER_ID_HALL_ENCODER0                 = 8
ENCODER_ID_HALL_ENCODER1                 = 9
ENCODER_ID_AMT21_ENCODER0                = 10
ENCODER_ID_AMT21_ENCODER1                = 11
ENCODER_ID_AMT21_ENCODER2                = 12
ENCODER_ID_ONBOARD_ENCODER0              = 13
ENCODER_ID_ONBOARD_ENCODER1              = 14

# ODrive.SpiEncoderMode
SPI_ENCODER_MODE_DISABLED                = 0
SPI_ENCODER_MODE_RLS                     = 1
SPI_ENCODER_MODE_AMS                     = 2
SPI_ENCODER_MODE_CUI                     = 3
SPI_ENCODER_MODE_AEAT                    = 4
SPI_ENCODER_MODE_MA732                   = 5

# ODrive.Controller.InputMode
INPUT_MODE_INACTIVE                      = 0
INPUT_MODE_PASSTHROUGH                   = 1
INPUT_MODE_VEL_RAMP                      = 2
INPUT_MODE_POS_FILTER                    = 3
INPUT_MODE_MIX_CHANNELS                  = 4
INPUT_MODE_TRAP_TRAJ                     = 5
INPUT_MODE_TORQUE_RAMP                   = 6
INPUT_MODE_MIRROR                        = 7
INPUT_MODE_TUNING                        = 8

# ODrive.Motor.MotorType
MOTOR_TYPE_HIGH_CURRENT                  = 0
MOTOR_TYPE_GIMBAL                        = 2
MOTOR_TYPE_ACIM                          = 3

# ODrive.Error
ODRIVE_ERROR_NONE                        = 0x00000000
ODRIVE_ERROR_CONTROL_ITERATION_MISSED    = 0x00000001
ODRIVE_ERROR_DC_BUS_UNDER_VOLTAGE        = 0x00000002
ODRIVE_ERROR_DC_BUS_OVER_VOLTAGE         = 0x00000004
ODRIVE_ERROR_DC_BUS_OVER_REGEN_CURRENT   = 0x00000008
ODRIVE_ERROR_DC_BUS_OVER_CURRENT         = 0x00000010
ODRIVE_ERROR_BRAKE_DEADTIME_VIOLATION    = 0x00000020
ODRIVE_ERROR_BRAKE_DUTY_CYCLE_NAN        = 0x00000040
ODRIVE_ERROR_INVALID_BRAKE_RESISTANCE    = 0x00000080

# ODrive.Can.Error
CAN_ERROR_NONE                           = 0x00000000
CAN_ERROR_DUPLICATE_CAN_IDS              = 0x00000001

# ODrive.Axis.Error
AXIS_ERROR_NONE                          = 0x00000000
AXIS_ERROR_INVALID_STATE                 = 0x00000001
AXIS_ERROR_WATCHDOG_TIMER_EXPIRED        = 0x00000800
AXIS_ERROR_MIN_ENDSTOP_PRESSED           = 0x00001000
AXIS_ERROR_MAX_ENDSTOP_PRESSED           = 0x00002000
AXIS_ERROR_ESTOP_REQUESTED               = 0x00004000
AXIS_ERROR_HOMING_WITHOUT_ENDSTOP        = 0x00020000
AXIS_ERROR_OVER_TEMP                     = 0x00040000
AXIS_ERROR_UNKNOWN_POSITION              = 0x00080000

# ODrive.Motor.Error
MOTOR_ERROR_NONE                         = 0x00000000
MOTOR_ERROR_DRV_FAULT                    = 0x00000008
MOTOR_ERROR_CONTROL_DEADLINE_MISSED      = 0x00000010
MOTOR_ERROR_MODULATION_MAGNITUDE         = 0x00000080
MOTOR_ERROR_CURRENT_SENSE_SATURATION     = 0x00000400
MOTOR_ERROR_CURRENT_LIMIT_VIOLATION      = 0x00001000
MOTOR_ERROR_MODULATION_IS_NAN            = 0x00010000
MOTOR_ERROR_MOTOR_THERMISTOR_OVER_TEMP   = 0x00020000
MOTOR_ERROR_FET_THERMISTOR_OVER_TEMP     = 0x00040000
MOTOR_ERROR_TIMER_UPDATE_MISSED          = 0x00080000
MOTOR_ERROR_CURRENT_MEASUREMENT_UNAVAILABLE = 0x00100000
MOTOR_ERROR_CONTROLLER_FAILED            = 0x00200000
MOTOR_ERROR_I_BUS_OUT_OF_RANGE           = 0x00400000
MOTOR_ERROR_BRAKE_RESISTOR_DISARMED      = 0x00800000
MOTOR_ERROR_SYSTEM_LEVEL                 = 0x01000000
MOTOR_ERROR_BAD_TIMING                   = 0x02000000
MOTOR_ERROR_UNKNOWN_PHASE_ESTIMATE       = 0x04000000
MOTOR_ERROR_UNKNOWN_PHASE_VEL            = 0x08000000
MOTOR_ERROR_UNKNOWN_TORQUE               = 0x10000000
MOTOR_ERROR_UNKNOWN_CURRENT_COMMAND      = 0x20000000
MOTOR_ERROR_UNKNOWN_CURRENT_MEASUREMENT  = 0x40000000
MOTOR_ERROR_UNKNOWN_VBUS_VOLTAGE         = 0x80000000
MOTOR_ERROR_UNKNOWN_VOLTAGE_COMMAND      = 0x100000000
MOTOR_ERROR_UNKNOWN_GAINS                = 0x200000000
MOTOR_ERROR_CONTROLLER_INITIALIZING      = 0x400000000

# ODrive.SensorlessEstimator.Error
SENSORLESS_ESTIMATOR_ERROR_NONE          = 0x00000000
SENSORLESS_ESTIMATOR_ERROR_UNSTABLE_GAIN = 0x00000001
SENSORLESS_ESTIMATOR_ERROR_UNKNOWN_CURRENT_MEASUREMENT = 0x00000002
